/*	Link party program	*/
/*	Part of CHAT, Copyright 1988 Macro Computer Solutions, Inc	*/
	
#include	"chat.h"
#include	"decl.h"

char	filen[132];
int	echo = 1;			/* Start with echo off */
struct	termio	oldbuf, tbuf;

execcmd(cmd)
char	*cmd;

{
char	*arg[30];
int	x=0;
char	*ptr;
long	wloc;

	if (fork() == 0) {
		ptr = strtok(cmd,":;, ");
		arg[x++]=ptr;
		while ((arg[x++] = strtok((char *) NULL, " ,")) != NULL);;
		signal(SIGINT, SIG_DFL);
		signal(SIGQUIT, SIG_DFL);
		exit(execvp(arg[0], arg));
	} else wait(&wloc);
	return((int) wloc);
}


getline(line)
char	*line;

{

	int	ch;
	int	x, y;
	int	flags;
	int	index = 1;
	static	char	line2[80] = {0};
	char	tmpx[80], tmpy[80];

	if (strlen(line2) != 0) {
		printf("> %s", line2);
		fflush(stdout);
		strcpy(line, line2);
		index = strlen(line2);
		line2[0] = 0;
		goto readmore;
	}
loop1:;
	alarm(1);
	if ((ch = getchar()) == EOF)  {
		alarm(0);
		return(0);
	}
	if ((ch == 13) || (ch == 10)) 
		return(0);
	if ((ch < 32) || (ch > 126)) 
		goto loop1;
	if (ch == '^')
		ch = 10;
	line2[0] = 0;
	line[0] = ch;
	if (echo == 0) {
		printf("> %c",ch);
		fflush(stdout);
	}

readmore:;

	alarm(120);				/* 120 seconds on the line */
	x = 0;
	while (index < 68) {			/* We get up to 68 chars */
		if (index != 0) x = -1; else x = 0;
		ch = getchar();			/* Get one */
		if (ch == EOF) {		/* If EOF.... */
			line[index] = 0;
			puts("");
			x = 0;
			break;
		}
		if ((ch == 24) || (ch == 21)) {	/* Cancel request... */
			puts("\n[Cancelled]");
			alarm(0);
			return(0);
		}
		if ((ch == 13) || (ch == 10)) {	/* End of line */
			line[index] = 0;
			if (echo == 0) puts("");
			alarm(0);
			if (index == 0) return(0);
			return(-1);
		}
		if (ch == '^')
			ch = 10;
		if (ch == '}')
			ch = 10;
		if ((ch < 32) || (ch > 126)) continue;	/* Do nothing */
		line[index++] = ch;		/* Add the character */
		if (echo == 0) {
			putchar(ch);
			fflush(stdout);
		}
	}					/* Falling off end... */
	x = -1;					/* Init return code */
	if (index == 0)
		return(0);			/* Nothing on the line */
	if (index == 68) {			/* Look for break location */
		index--;
		y = line[index--];		/* Get last character */
		while ((index > 0) && (y != ' ')) {	/* Find last space */
			if (echo == 0) {		/* Do we echo?? */
				putchar(8);
				putchar(32);		/* Cover thy spaces! */
				putchar(8);
			}
			y = line[index--];		/* Check next back */
		}
		if (index == 0) return(-1);		/* No break, send it */
		index++;				/* Break at next */
		line[index] = 0;			/* Store break */
		ch = line[1];
		if (ch >= 'a') ch = tolower(ch);	/* Make lower case */
		if ((line[0] == '.') && ((ch == 'p') || (ch == 't'))) {
			sprintf(tmpx, "%s", &line[2]);
			sscanf(tmpx, " %[!-~]", tmpy);	/* Get name */
			strncpy(line2, line, 2);
			line2[2] = 0;
			strcat(line2, tmpy);		/* Add name */
			strcat(line2, " ");
			strcat(line2, &line[index + 1]);
		} else 
			strcpy(line2, &line[index + 1]);/* Copy rest.. */
		x = strlen(line2);			/* Get length */
		if (x == 0) x = -1;			/* Return length */
		if (echo == 0) puts("");		/* New line */
	}
	alarm(0);					/* No alarms please */
	return(x);					/* Exit w/status */
}

/*	And here we find a variety of signal catching routines.

	catch() exists only to satisfy the alarm call requirements.

	The rest are exits of various kinds, some forced by external
	circumstances, others requested by either the daemon or the user.

*/

catch()
{
	signal(SIGALRM, catch);
	return;
}

servdied()
{
	puts("[Server disconnected]");
	die1();
}

samename()
{
	puts("Only one chat per user id allowed!");
	die1();
}

toss()
{
	puts("You have been removed from CHAT by another user");
	die1();
}

full()
{
	puts("CHAT is full, please try again later");
	die1();
}

die1()
{
	puts("Bye-bye");
	unlink(filen);
	ioctl(0,TCSETAW,&oldbuf);
	exit(0);
}

/*	This is it... not many comments, but then again this is
	pretty simple code... Shouldn't be hard to understand..

*/

main(argc, argv)
int	argc;
char	*argv[];

{
	char	temp[132];
	char	line[132], line2[132];
	char	victim[20], msg[80];
	int	out;
	int	cp;
	FILE	*ttynq;
	int	fid, wr;
	char	key;
	int	x;
	struct	passwd	*psw;
	struct utmp *ptr, *user, *getutent();
	char	name[20];
	char	cmd[5] ;
	int	channel = 0;

	umask(0117);
	if (argc == 2) 
		strcpy(name, argv[1]);
	else {
		psw = getpwuid(getuid());	/* A shot at the user */
		strcpy(name, psw->pw_name);	/* Pick up a starting name */
	}
	fprintf(stderr,"Link/Chat V2.2, %s\n", name);
	strcpy(cmd,"z");			/* Base command */
	signal(SIGALRM,catch);			/* Do nothing here */
	signal(SIGQUIT, toss);			/* Toss user */
	signal(SIGINT, die1);			/* Quit if requested */
	signal(SIGUSR1, full);			/* No channels available */
	signal(SIGUSR2, samename);		/* No second by same name */
	signal(SIGPIPE, servdied);		/* The server was killed */
	out = 0;
	sprintf(line, "%spipe%d", CHATDIR, getpid());/* infeed */
	strcpy(filen, line);			/* Save for later */

/* This had better not fail; if it does, then you're effectively screwed as
the server cannot find you.  One way around this is to put these in the /tmp
directory, which is nearly always writable.  We do that here	*/

	if (mknod(line, 010770, 0) != 0) {
		puts("Insufficient privilege for communication channel;");
		perror("mknod");
		puts("Please contact an administrator");
		exit();
	}
	ioctl(0,TCGETA,&tbuf);			/* Get working copy */
	ioctl(0,TCGETA,&oldbuf);		/* And copy for restore later */
	tbuf.c_lflag &= ~(ICANON|ECHO|ISIG);	/* Clean input, echo */
	tbuf.c_cc[4] = 1;			/* 1 character, 1 second */
	tbuf.c_cc[5] = 1;
	ioctl(0,TCSETAW,&tbuf);			/* Set tty */
	strcpy(temp, CHATDIR);			/* THIS one is private */
	strcat(temp, "pipe");
	if ((wr = open(temp, O_WRONLY|O_NDELAY)) == -1) {
		puts("Wait, attempting to start comserver");
		execcmd("comserver");
		for (x = 0; x < MAXTRIES; x++) {
			if ((wr = open(temp, O_WRONLY|O_NDELAY)) != -1) 
				break;
#ifdef	NAP
			nap(NAPTIME);
#else
			sleep(NAPTIME);
#endif

		}
		if (wr == -1) {
			puts("Cannot establish communications, please try later");
			ioctl(0,TCSETAW,&oldbuf);	/* Restore terminal */
			unlink(line);
			exit(1);
		}
	}
	sprintf(temp, "%d o %d %s >%s\n", getpid(), channel, name, name);
	write(wr, temp, LINESIZ);		/* Write one buffer. */
	alarm(10);
	fid = 0;				/* Make pipe id impossible */
	fid = open(line, O_RDONLY);		/* Open pipe for reading */
	if (fid <= 0) {
		ioctl(0,TCSETAW,&oldbuf);	/* Leave if no server */
		unlink(line);
		exit(1);
	}
	setgid(getgid());			/* Turn off permissions */
	setuid(getuid());			/* We have the files open */
	alarm(0);				/* Cancel outstanding alarm */
	sprintf(temp, "%d %s %d %s >%s\n",getpid(), "s", channel, name, "test");
	write(wr, temp, LINESIZ);
	while (out == 0) {			/* While still scanning */
		alarm(1);			/* Interrupt in one second */
		while (read(fid, temp, LINESIZ) == LINESIZ) {
			stripj(temp);		/* Read/print while available */
			puts(temp);		/* Get next line */
			alarm(1);		/* Reset alarm */
		}
		if (getline(line) != 0) {	/* Did we get user input? */
			if (*line == '.') {	/* Command request... */
				switch(line[1]) {
					case 'p':	/* Private message */
					case 'P':
						if (sscanf(&line[2], " %s %[!-~ ]", victim, msg) == 2) {
							sprintf(temp, "%d %s %d %s >%s\n",getpid(), "p", channel, victim, msg);
							write(wr, temp, LINESIZ);
						} else puts("Requires user and message");
						break;
					case 't':	/* Tell someone */
					case 'T':
						if (sscanf(&line[2], " %s %[!-~ 	]",victim, msg) < 2) {
							puts("Chat/Link: Requires victim and message");
							break;
						}
						x = 0;
						setutent();	/* Find user */
						while ((ptr = getutent()) != NULL)   {
							if (strncmp(ptr->ut_user, victim, (strlen (victim) -1)) == 0)   {
								user = ptr;
								x = 1;
								break;
							}
						}
						if ( !x)   {
							printf ("User is not logged on\n");
							break;
						}
						strcpy (temp, "/dev/");
						strcat (temp, user->ut_line);
						alarm(10);
						if ((ttynq = fopen (temp, "w")) == NULL)   {
							printf ("User %s has disabled writes\n", user->ut_user);
						} else {
							fclose (ttynq);
							strcpy (temp, "echo \"\n;;From ");
							strcat (temp, name);
							strcat (temp, ": ");
							strcat (temp, msg);
							strcat (temp, " \" >/dev/");
							strcat (temp, user->ut_line);
							alarm(10);
							system (temp);
						}
						alarm(0);
						break;
					case 'k':	/* Request kill */
					case 'K':
						sprintf(temp, "%d %s %d %s >%s\n",getpid(), "k", channel, &line[2], "test");
						write(wr, temp, LINESIZ);
						break;
					case 'c':
					case 'C':
						sprintf(temp, "%d %s %d %s >%s\n", getpid(), "t", atoi(&line[2]), " ", " ");
						channel = atoi(&line[2]);
						write(wr, temp, LINESIZ);
						break;
					default:	/* Bad command */
						break;
				}
			} else {		/* Otherwise send the line */
				sprintf(temp, "%d %s %d %s >%s\n", getpid(), cmd, channel , name, line);
				write(wr, temp, LINESIZ);
			}
		}
	}
}

