/*	Server.c	- server process */

#include	"chat.h"
#include	"decl.h"


FILE *fdup(fp)
register FILE *fp;
{
	int newfd;
	char *mode;

	if ((newfd = dup(fileno(fp))) != -1) {
		return(fdopen(newfd,"r+"));
	} else return(NULL);
}

struct	termio	tbuf, oldbuf;

die1()
{
	exit(1);
}

main(argc, argv)
int	argc;
char	*argv[];
{
	
	FILE	*fid2;
	char	temp[132];
	char	savename[21];
	char	names[400];
	char	alias[400];
	int	pids[20], channels[20];
	int	fids[20], fid;
	int	count = 0, channel;
	char	cmd[5];
	char	name[40], nm[40];
	char	msg[132];
	int	pid;
	char	tmp[132];
	int	x, y, z, out;
	int	keep = 0;
	int	anywrite = 0;

	if (argc > 2)
		puts("[ComServer V2.5]");
	sprintf(tmp, "%spipe", CHATDIR);
	unlink(tmp);				/* Insure nothing here */
	if (mknod(tmp, 010770, 0) != 0) {
		puts("Cannot make master pipe file");
		exit(1);
	}
	chown(tmp, geteuid(), getegid());	/* Set to proper uid, gid */
	chmod(tmp, 0660);			/* Set file mode */
	if (*argv[1] != 'f') {			/* Only if not 'comserver f' */
	if (fork() > 0) 
		exit(0);			/* Successfully in background */

/* We are now in the child process, and have everything ready to go.
   Detach from the terminal, then make a new control terminal and go to it */

	close(0);
	close(1);
	close(2);
	fclose(stdin);
	fclose(stdout);
	fclose(stderr);
	if (argc > 2)
		fopen("/dev/console", "r+");	/* Make Control terminal */
	else
		fopen("/dev/null", "r+");	/* Make null terminal */
	fdup(stdin);
	fdup(stdin);
	setbuf(stdin, NULL);
	setbuf(stdout, NULL);
	}
	fid = open(tmp, O_RDONLY, 0660);	/* Open pipe file */
	unlink("/tmp/chat.lock");
	puts("[ComServer] V2.5; startup");
	while (read(fid, tmp, LINESIZ) == LINESIZ) {
	strcpy(temp, tmp);
	signal(SIGPIPE,SIG_IGN);		/* Ignore writes on pipes */
	if (sscanf(temp, " %d %s %d %s >%[!-~ 	]", &pid, cmd, &channel, name, msg) >= 2) {
		puts(temp);
		switch (*cmd) {
			case 'k':		/* Kill user */
				x = 0;
				while (x < count) {
					if (pids[x] == pid) {
						out = fids[x];
						break;
					}
					x++;
				}
				sprintf(tmp, "%s/CHAT.sus");
				y = 0;			/* Flag no match */
				if ((fid2 = fopen(tmp, "r")) != NULL) {
					while (fgets(tmp, 20, fid2) != NULL) {
						stripj(tmp);
						if (strcmp(tmp, &names[x*20]) == 0) {
							y++;
							break;
						}
					}
					fclose(fid2);
					if (y == 0) {
						sprintf(tmp, "[Server]: Insufficient privilege\n");
						write(out, tmp, LINESIZ);
						break;
					}
				}
				x = 0;
				while (x < count) {
					if (strcmp(&names[x*20], name) == 0) {
						kill(pids[x], SIGQUIT);
						sprintf(tmp, "[Server]: Killed %s (%d)\n", name, pids[x]);
						write(out, tmp, LINESIZ);
						y = x;
						sprintf(tmp, "%s/pipe%d", CHATDIR, pids[x]);
						unlink(tmp);
						break;
					}
					x++;
				}
				if (x == count) {
					sprintf(tmp, "No user: %s\n", name);
					write(out, tmp, LINESIZ);
				}
				break;
			case 'p':		/* Send private message */
				x = 0;
				while (x < count) {
					if (pids[x] == pid) {
						strcpy(tmp, &names[20*x]);
						out = fids[x];
						break;
					}
					x++;
				}
				x = 0;
				while (x < count) {
					if (strcmp(&names[x*20], name) == 0) {
						sprintf(temp, "Prv from [%s]: %s\n", tmp, msg);
						write(fids[x], temp, LINESIZ);
						sprintf(tmp, "Prv sent to %s\n", name);
						write(out, tmp, LINESIZ);
						break;
					}
					x++;
				}
				if (x == count) {
					sprintf(temp, "User not in chat: %s\n", name);
					write(out, temp, LINESIZ);
				}
				break;
			case 's':		/* Request for status */
				x = 0;
				printf("Send status to %d\n",pid);
				while (x < count)  {
					printf("Pid: %d and %d\n", pids[x], pid);
					if (pids[x] == pid) {
						y = fids[x];
						break;
					}
					x++;
				}
				if (x == count) break;	/* Invalid */
				x = 0;
				printf("Sending via fid %d\n",y);
				sprintf(tmp, "");
				write(y, tmp, LINESIZ);
				sprintf(tmp, "Chat user  (Alias)");
				write(y, tmp, LINESIZ);
				anywrite = 0;
				while (x < count) {
					if (strcmp(&names[x*20], &alias[x*20]) == 0)
						sprintf(tmp, "%s\n",&names[x*20]);
					else
						sprintf(tmp, "%-10s (%s)\n",&names[x*20], &alias[x*20]);
						
					write(y, tmp, LINESIZ);
					anywrite++;
					x++;
				}
				if (anywrite < 2) {
					sprintf(tmp, "{No other users in CHAT}");
					write(y, tmp, LINESIZ);
				}
				sprintf(tmp, " ");
				write(y, tmp, LINESIZ);
				break;
			case 'o':	/* Open a new channel */
				x = 0;
				while (x < count) {	/* Only one per name */
					if (strcmp(name, &names[x*20]) == 0) {
						kill(pid, SIGUSR2);
						break;
					}
					x++;
				}
				if (x != count) break;
				if (count > 15) {
					kill(pid, SIGUSR1);	/* Special */
					x = 0;
					sprintf(tmp, "[Server]: Full, refused %s\n", name);
					while (x < count) {
						write(fids[x++], tmp, LINESIZ);
					}
					
					break;
				}
				printf("Opening channel: %d\n",pid);
				sprintf(tmp, "%s/pipe%d", CHATDIR, pid);
				strcpy(&names[count*20],name);
				strcpy(&alias[count*20],name);
				printf("Open pipe file %s\n", tmp);
				if ((fids[count] = open(tmp,O_WRONLY)) < 0) {
					perror("Pipe failure:");
					puts("(someone will be disappointed!)");
					break;
				}
				x = fcntl(fids[count], F_GETFL, 0);
				fcntl(fids[count], F_SETFL, x |= O_NDELAY);
				pids[count] = pid;
				channels[count] = 0;
				count++;
				x = 0;
				printf("Added pid %d\n",pids[count - 1]);
				sprintf(tmp, "[Connected V2.5]\n\n");
				write(fids[count - 1], tmp, LINESIZ);
				sprintf(tmp, "%c>> Welcome %s.\n", 7, name);
				while (x < count) {
					write(fids[x++], tmp, LINESIZ);
				}
				break;
			case 'n':	/* Change name (alias) */
				x = 0;
				while (x < count) {
					if (pid == pids[x]) break;
					x++;
				}
				if (x == count) break;	/* Bad request */
				printf("Alias: %s to %s\n", &names[x*20], msg);
				strncpy(&alias[x*20], msg, 20);
				alias[(x*20)+19] = 0;
				sprintf(tmp, "[Server]: %s aliased to (%s)\n", &names[x*20], &alias[x*20]);
				write(fids[x], tmp, LINESIZ);
				break;
			case 't':
				sprintf(tmp, "[Server]: Channel changed to %d", channel);
				for (x = 0; x < count; x++) {
					if (pids[x] == pid) {
						channels[x] = channel;
						write(fids[x], tmp, LINESIZ);
					}
				}
				break;
			case 'q':	/* Kill a user */
				x = 0;
				while (x < count) {
					if (pid == pids[x]) break;
					x++;
				}
				if (x == count) {
					puts("Bad quit request");
					break;	/* Bad request */
				}
				printf("Leaving: %s (%d left)\n",&names[x*20],(count - 1));
				sprintf(temp, "%s/pipe%d", CHATDIR, pid);
				unlink(temp);		/* Remove pipe file */
				strcpy(savename, &names[20*x]);
				y = x;
				while (y < count) {
					pids[y] = pids[y + 1];
					fids[y] = fids[y + 1];
					strcpy(&names[y*20], &names[(y+1)*20]);
					strcpy(&alias[y*20], &alias[(y+1)*20]);
					y++;
				}
				count--;		/* Fall through */
			case 'w':	/* Write a message */
				x = 0;
				while (x < count) {
					if (pid == pids[x]) break;
					x++;
				}
				if (x != count) strcpy(savename, &alias[x*20]);
				printf("Write message: %s %s\n",savename, msg);
				sprintf(tmp, "%s: %s\n",savename, msg);
				savename[0] = 0;	/* Clear name */
				x = 0;
				while (x < count) {
					if (channels[x] != channel) {
						x++;
						continue;
					}
					if (pid == pids[x]) {
						x++;
						continue;
					}
					if ((write(fids[x], tmp, LINESIZ) == -1) && (errno = EPIPE)) {
						y = x;
						z = pids[x];
						strcpy(nm, &names[x*20]);
						while (y < count) {
							fids[y] = fids[y+1];
							pids[y] = pids[y+1];
							strcpy(&names[y*20],&names[(y + 1)*20]);
							strcpy(&alias[y*20], &alias[(y+1)*20]);
							y++;
						}
						count--;
						y = 0;
						sprintf(tmp, "%s/pipe%d", CHATDIR, z);
						unlink(tmp);
						sprintf(tmp, "[Server]: %s disappears in a puff of smoke!\n",nm);
						while (y < count) 
							write(fids[y++],tmp,LINESIZ);
						x--;
					}
					x++;
				}
				break;
			case 'z':	/* Write QUIET */
				x = 0;
				while (x < count) {
					if (pid == pids[x]) break;
					x++;
				}
				if (x != count) strcpy(savename, &alias[x*20]);
				printf("Write QUIET message: %s %s\n",savename, msg);
				sprintf(tmp, "%s:%s\n",savename, msg);
				savename[0] = 0;	/* Clear name */
				x = 0;
				while (x < count) {
					if (channels[x] != channel) {
						x++;
						continue;
					}
					if (pid == pids[x]) {
						x++;
						continue;
					}
					if ((write(fids[x], tmp, LINESIZ) == -1) && (errno = EPIPE)) {
						y = x;
						z = pids[x];
						strcpy(nm, &names[x*20]);
						while (y < count) {
							fids[y] = fids[y+1];
							pids[y] = pids[y+1];
							strcpy(&names[y*20],&names[(y + 1)*20]);
							strcpy(&alias[y*20], &alias[(y+1)*20]);
							y++;
						}
						count--;
						y = 0;
						sprintf(tmp, "%s/pipe%d", CHATDIR, z);
						unlink(tmp);
						sprintf(tmp, "[Server]: %s disappears in a puff of smoke!\n",nm);
						while (y < count) 
							write(fids[y++],tmp,LINESIZ);
						x--;
					}
					x++;
				}
				break;
			default:
				x = 0;
				while (x < count) {
					if (pids[x] == pid) {
						y = fids[x];
						break;
					}
					x++;
				}
				if (x == count) break;	/* Invalid */
				sprintf(tmp, "Illegal server request\n");
				write(y, tmp, LINESIZ);
		}
	}
	}
}
